//
//  test22.cpp
//  Lecture3CPP
//
//  Created by presentations on 11/15/17.
//
//

#include <iostream>
#include <string>
#include <iomanip>
using namespace std;


class Employee {
public:
    Employee( const string , const string  );  // constructor
    void print() const;                        // output first and last name
private:
    string firstName;
    string lastName;
    
}; // end class Employee (interface)

// class Employee (implementation)

Employee::Employee( const string first, const string last ) // Employee constructor
{
    firstName = first;
    lastName = last;
}

void Employee::print() const
{
    cout << firstName << ' ' << lastName;
}
// end class Employee (implementation)


class HourlyWorker : public Employee {  // HourlyWorker inherits from Employee
    
public:
    HourlyWorker( const string , const string , double, double );
    double getPay() const;      // calculate and return salary
    void print() const;         // overridden base-class print
private:
    double wage;                // wage per hour
    double hours;                // hours worked
};


HourlyWorker::HourlyWorker( const string first, const string last, double initHours, double initWage ) : Employee(first, last)
{
    hours = initHours;      // should validate
    wage = initWage;       // should validate
} // end HourlyWorker constructor

double HourlyWorker::getPay() const
{
    return wage * hours;
}

void HourlyWorker::print() const
{// overriding the print function in the base class
    cout << "HourlyWorker::print() is executing\n\n";
    Employee::print();   // call base-class print function
    cout << " is an hourly worker with pay of $" << setiosflags( ios::fixed | ios::showpoint ) << setprecision( 2 ) << getPay() << endl;
} // end function print

// end class HourlyWorker


int main()
{
    HourlyWorker h( "Bob", "Smith", 40.0, 10.00 );
    h.print();
    return 0;
} // end function main
